#include "redica.h"
#include<bits/stdc++.h>
using namespace std;
int s=0;
int k;
int n;
int su;
vector<int>ve;
void genr(int l)
{
    if(l==n-1)
    {
        if(su-s>k)return;
        ve.push_back(su-s);
        submit(ve);
        ve.pop_back();
        return;
    }
    for(int i=1;i<=k;i++)
    {
        ve.push_back(i);
        s+=i;
        if(s>su)
        {
            s-=i;
            ve.pop_back();
            return;
        }
        genr(l+1);
        s-=i;
        ve.pop_back();
    }
}
void solve(int N, int K, int S)
{
    ve.clear();
    n=N;
    k=K;
    su=S;
    int h;
    int br=n-2;
    for(int i=1;i<=br;i++)
    {
        h=query();
        s+=h;
        ve.push_back(h);
    }
    if(br<0)genr(0);
    else genr(br);
    return;
}
